/* Microsoft SQL Server - Scripting			*/
/* Server: Nallepuh / FileChk ReMAINT			*/
/* Database: StrsArchive/Mik1998				*/
/* Creation Date 10/7/98 1:16:16 PM 			*/

/****** Object:  Stored Procedure dbo.sp_filechk    Script Date: 1998-10-07 13:16:16 ******/
if exists (select * from sysobjects where id = object_id('dbo.sp_filechk') and sysstat & 0xf = 4)
	drop procedure dbo.sp_filechk
GO
/****** Object:  Stored Procedure dbo.remaint    Script Date: 1998-10-07 13:16:16 ******/
if exists (select * from sysobjects where id = object_id('dbo.remaint') and sysstat & 0xf = 4)
	drop procedure dbo.remaint
GO

/****** Object:  Stored Procedure dbo.sp_filechk    Script Date: 1998-10-07 13:16:16 ******/
CREATE PROCEDURE sp_filechk 
WITH ENCRYPTION
AS
UPDATE object 
set filechk = 1
where filechk = 0
-- Batch (make stored procedure of it) to check if files exists
SET NOCOUNT ON
-- Table to hold all distinct path names
CREATE TABLE #filepath (path VARCHAR(255), is_there tinyint NULL)

-- Populate the table with the distinct path names
INSERT #filepath (path)
SELECT DISTINCT SUBSTRING(object_file, 1, DATALENGTH(object_file) - PATINDEX('%\%', REVERSE(object_file))) FROM object WHERE arch_id IS NULL

-- Table to hold all filenames from the paths
CREATE TABLE #files (filename VARCHAR(255))
--CREATE CLUSTERED INDEX idx_files ON files (filename) WITH ALLOW_DUP_ROW
--truncate table files

-- The folllowing cursor performs DIR for all paths and inserts the result into #files
DECLARE path_cur CURSOR FOR
 SELECT path FROM #filepath
OPEN path_cur

DECLARE @path VARCHAR(255), @err INT, @exc VARCHAR(255)
FETCH NEXT FROM path_cur INTO @path
WHILE @@FETCH_STATUS = 0 --While everything is OK
BEGIN
 SELECT @exc = "master..xp_cmdshell 'DIR " + @path + " /b'"
 INSERT #files
 EXEC(@exc)
 FETCH NEXT FROM path_cur INTO @path
END

CLOSE path_cur
DEALLOCATE path_cur

/* CHECK IF ACCESS IS  DENIED ON FILESYSTEM/MIK */
IF (select COUNT(*) from #files WHERE FILENAME like 'Access is denied%') >0
   	BEGIN 
	raiserror('Error in Filecheck, Access is Denied!  Killing the SPID now.' ,22,127) with log
	END
ELSE 
  BEGIN
CREATE TABLE #object (object_id INT)

-- Populate the table with the distinct path names
INSERT #object (object_id)
SELECT object_id
FROM object 
WHERE Not exists (select * from #files where REVERSE(SUBSTRING(SUBSTRING(REVERSE(object_file), 2, 255), 1, PATINDEX('%\%', REVERSE(object_file)) -2)) = filename ) 
AND arch_id IS NULL

UPDATE object
 SET filechk = 0
--where filechk = 0
from object o, #object t
Where o.object_id = t.object_id

END
DECLARE @i_missing_files INT         -- Number of missing files
DECLARE @i_err_lvl INT               -- Severity level that we shall pass to RAISERROR
SELECT @i_missing_files = (SELECT COUNT(*) FROM object WHERE filechk = 0)

--Set severity level (<15 is info, 15 is warning, >15 is error)
IF @i_missing_files = 0
 SELECT @i_err_lvl = 11 ELSE SELECT @i_err_lvl = 16

--Generate log entry (this can be IF'ed and modified to desire)
--RAISERROR ("Det saknas %d fil(er) i filsystemet.", @i_err_lvl, 1, @i_missing_files)
RAISERROR ("Number of files missing %d.", @i_err_lvl, 1, @i_missing_files)

DROP TABLE #files
DROP TABLE #filepath
DROP TABLE #object
GO


CREATE PROC remaint 
WITH ENCRYPTION
AS
 EXEC sp_checkident
 EXEC sp_filechk
GO



